// pimgdirup.cpp : Defines the entry point for the application.
//

#include "stdafx.h"

/* Defines */
#define APP_MUTEX_NAME					_T("PIMGDIRUP App Mutex")

#define PIMG_WINDOW_CLASS_NAME			_T("PICTURESAPP")
#define PIMG_FILE_PATH					_T("\\Windows\\pimg.exe")
#define PIMG_REGKEY_NAME				_T("Software\\Microsoft\\Pictures")
#define PIMG_LASTLOCATION_VALUE_NAME	_T("LastLocation")
#define PIMG_LOCALPATH_VALUE_NAME		_T("LocalPath")
#define PIMG_STORAGECARDPATH_VALUE_NAME	_T("StorageCardPath")
#define PIMG_DIRECTORY_OPTION			_T("-directory:")


static
void
PimgDirectoryUp()
{
 	
	HKEY	hKey = NULL;
	BOOL	bGetDirectory;
	LONG	lResult;
	TCHAR	szDirectory[MAX_PATH + 1];

	bGetDirectory = FALSE;	// WXgfBNgpXǂݍ߂H

	// 摜ƃrfIŌ݊JĂ(͍ŌɊJĂ)fBNg擾
	lResult = RegOpenKeyEx(HKEY_CURRENT_USER, PIMG_REGKEY_NAME, 0, 0, &hKey);
	if (lResult == ERROR_SUCCESS) {
		DWORD	dwSize;
		DWORD	dwType;
		DWORD	dwLocation;


		dwType = REG_DWORD;
		dwSize = sizeof(dwLocation);
		lResult = RegQueryValueEx(hKey, PIMG_LASTLOCATION_VALUE_NAME, 0, &dwType, (LPBYTE)&dwLocation, &dwSize);

		if (lResult == ERROR_SUCCESS) {
			switch(dwLocation) {
			case 0:
				dwType = REG_SZ;
				dwSize = sizeof(szDirectory);
				memset(szDirectory, 0, sizeof(szDirectory));
				lResult = RegQueryValueEx(hKey, PIMG_LOCALPATH_VALUE_NAME, 0, &dwType, (LPBYTE)szDirectory, &dwSize);
				if (lResult == ERROR_SUCCESS) {
					bGetDirectory = TRUE;
				}
				break;
			case 1:
				dwType = REG_SZ;
				dwSize = sizeof(szDirectory);
				memset(szDirectory, 0, sizeof(szDirectory));
				lResult = RegQueryValueEx(hKey, PIMG_STORAGECARDPATH_VALUE_NAME, 0, &dwType, (LPBYTE)szDirectory, &dwSize);
				if (lResult == ERROR_SUCCESS) {
					bGetDirectory = TRUE;
				}
				break;
			default:
				break;
			}
		}

		RegCloseKey(hKey);
		hKey = NULL;
	}
	//

	if (bGetDirectory) {
		// 摜ƃrfIŌ݊JĂ(͍ŌɊJĂ)fBNg̎擾ɐ

		BOOL	bRet;
		TCHAR	szOption[MAX_PATH + 32+ 1];
		LPTSTR	p = NULL;
		PROCESS_INFORMATION	pi;
		
		p = _tcsrchr(szDirectory, _T('\\'));
		if (p != NULL) {
			*p = _T('\0');

			if (_tcslen(szDirectory) == 0) {
				// [g
				wsprintf(szOption, TEXT("%s%s"), PIMG_DIRECTORY_OPTION, _T("\\"));
			}
			else {
				wsprintf(szOption, TEXT("%s%s"), PIMG_DIRECTORY_OPTION, szDirectory);
			}

			memset(&pi, 0, sizeof(pi));
			bRet = CreateProcess(PIMG_FILE_PATH, szOption, NULL, NULL, FALSE, 0, NULL, NULL, NULL, &pi);
			if (bRet) {
				CloseHandle(pi.hThread);
				CloseHandle(pi.hProcess);
			}
		}
	}
}


static
BOOL
TouchLeftMenu(
	HWND	hWnd
)
{
	BOOL	bRet = FALSE;
	HWND	hMenuWnd = NULL;
	DWORD	dwProcId = 0;
	DWORD	dwMenuProcId = 0;
	
	hMenuWnd = FindWindow(_T("MS_SOFTKEY_CE_1.0"), NULL);
	if (hMenuWnd != NULL) {
		GetWindowThreadProcessId(hWnd, &dwProcId);
		GetWindowThreadProcessId(hMenuWnd, &dwMenuProcId);

		if (dwProcId == dwMenuProcId) {
			SendMessage(hMenuWnd, WM_LBUTTONDOWN, 0, MAKELPARAM(0, 0));
			SendMessage(hMenuWnd, WM_LBUTTONUP, 0, MAKELPARAM(0, 0));

			bRet = TRUE;
		}
	}

	return bRet;
}


int
WINAPI
WinMain(
	HINSTANCE hInstance,
	HINSTANCE hPrevInstance,
	LPTSTR    lpCmdLine,
	int       nCmdShow
)
{
	HANDLE	hMutex = NULL;
	HWND	hWnd = NULL;

	// dN`FbN
	hMutex = CreateMutex(NULL, TRUE, APP_MUTEX_NAME);
	if (hMutex != NULL) {
		if (GetLastError() == ERROR_ALREADY_EXISTS) {

			CloseHandle(hMutex);
			hMutex = NULL;
			return FALSE;
		}
	}
	else {
		return FALSE;
	}


	hWnd = GetForegroundWindow();
	if (hWnd != NULL) {
		TCHAR	szClassName[32];
		BOOL	bDoDirUp = FALSE;

		memset(szClassName, 0, sizeof(szClassName));
		if (GetClassName(hWnd, szClassName, sizeof(szClassName)/sizeof(szClassName[0])) != 0) {
			if (_tcscmp(szClassName, PIMG_WINDOW_CLASS_NAME) == 0) {
				bDoDirUp = TRUE;
			}
		}

		if (bDoDirUp) {
			PimgDirectoryUp();
		}
		else {
			TouchLeftMenu(hWnd);
		}
	}


	ReleaseMutex(hMutex);
	CloseHandle(hMutex);
	hMutex = NULL;
	return FALSE;
}





